        TITLE Project Library Subroutine Module

INCLUDE PRROMID.H
INCLUDE PREXTDEC.H

*****************************************************************
* subroutines
*****************************************************************
NULLNAME BESJ0
*
::
   ( x -- real )
   DUP %ABS %8 %<
   ITE
      ::
        ( x )
         DUP %* DUP
         ( y,y )
         R1
         ( y,y,meta )
         EVPO
         ( y,z )
         SWAP S1
         ( z,y,meta )
         EVPO
         ( z,n )
         %/
      ;
      ::
         ( x )
         %ABS
         ( ax )
         %8 OVER %/
         ( ax,z )
         OVER % 0.785398164 %-
         ( ax,z,xx )
         OVERDUP %*
         ( ax,z,xx,y )
         DUP P1 EVPO
         ( ax,z,xx,y,pyp )
         3PICK %>%% %%COSRAD %%>% %*  ( avoiding MODE switches )
         ( ax,z,xx,y,pyp*cos )
         SWAP Q1 EVPO
         ( ax,z,xx,pyp*cos,pyq )
         ROT %>%% %%SINRAD %%>% %*  ( avoiding MODE switches )
         ( ax,z,pyp*cos,pyq*sin )
         ROT %*
         %-
         ( ax,pyp*cos-z*pyq*sin )
         % 0.636619772 ROT %/ %SQRT
         %*
      ;
;
*****************************************************************
NULLNAME BESJ1
*
::
   ( x -- real )
   DUP %ABS %8 %<
   ITE
      ::
         ( x )
         DUPDUP %* DUP
         ( x,y,y )
         R2
         ( x,y,y,meta )
         EVPO
         ( x,y,z' )
         ROT %*
         ( y,z )
         SWAP S2
         ( z,y,meta )
         EVPO
         ( z,n )
         %/
      ;
      ::
         ( x )
         DUP %ABS
         ( x,ax )
         %8 OVER %/
         ( x,ax,z )
         OVER % 2.356194491 %-
         ( x,ax,z,xx )
         OVERDUP %*
         ( x,ax,z,xx,y )
         DUP P2 EVPO
         ( x,ax,z,xx,y,pyp )
         3PICK %>%% %%COSRAD %%>% %* ( ... )
         ( x,ax,z,xx,y,pyp*cos )
         SWAP Q2 EVPO
         ( x,ax,z,xx,pyp*cos,pyq )
         ROT %>%% %%SINRAD %%>% %* ( avoiding MODE switches )
         ( x,ax,z,pyp*cos,pyq*sin )
         ROT %*
         %-
         ( x,ax,pyp*cos-z*pyq*sin )
         % 0.636619772 ROT %/ %SQRT
         %*
         ( x,ans )
         SWAP %0<
         IT %CHS
      ;
;
*****************************************************************
NULLNAME BESJN
*
::
   DEFINE JNtox>  1GETLAM
   DEFINE >JNtox  1PUTLAM
   DEFINE JNjsum> 2GETLAM
   DEFINE >JNjsum 2PUTLAM
   DEFINE JNx>    3GETLAM
   DEFINE >JNx    3PUTLAM
   DEFINE JNn>    4GETLAM
   DEFINE >JNn    4PUTLAM

   ( n,x -- integer,real )
   DUP%0=
   ITE
     ::
       ( n,x )
       SWAPDROP
       ( 0 )
     ;
     ::
       ( n,x )
       %0 %0
       ( n,x,jsum,tox )
       { NULLLAM NULLLAM NULLLAM NULLLAM }
       BIND

       JNx> %ABS
       ( ax )
       JNn> OVER
       ( ax,n,ax )
       %<
       ITE
          ::
            ( ax )
            %2 OVER %/ >JNtox
            ( ax )
            DUP BESJ0
            ( ax,bjm )
            SWAP BESJ1
            ( bjm,bj )
            JNn> COERCE
            ONE_DO (DO)
                ( bjm,bj )
                DUP
                INDEX@ UNCOERCE %*
                ( bjm,bj,bj*i )
                JNtox> %*
                ( bjm,bj,bj*i*tox )
                ROT %-
                ( bj,tox*i*bj-bjm )
            LOOP (LOOP)
            ( bj,tox*i*bj-bjm )
            SWAPDROP
          ;
          ::
            ( ax )
            %2 SWAP %/ >JNtox
            ( the 40.0 could be changed to a larger )
            ( value to increase accuracy  )
            JNn> % 40.0 %* %SQRT %2 %/ %IP JNn> %+ %2 %*
            ( m )
            %0 >JNjsum
            %0 DUPDUP %1
            ( m,ans,sum,bjp,bj )
            5ROLL COERCE
            #1+_ONE_DO (DO)
                ( m,ans,sum,bjp,bj )
                ISTOP@ INDEX@ #- UNCOERCE
                ( m,ans,sum,bjp,bj,i )
                JNtox> %* OVER %*
                ( m,ans,sum,bjp,bj,i*tox*bj )
                ROT %-
                ( m,ans,sum,bj,i*tox*bj-bjp )
                DUP
                ( BIGNO )
                %ABS % 1.0e10 %>
                IT
                   ::
                     ( m,ans,sum,bjp,bj )
                     % 1.0e-10 %* 4UNROLL
                     % 1.0e-10 %* 4UNROLL
                     % 1.0e-10 %* 4UNROLL
                     % 1.0e-10 %* 4UNROLL
                   ;
                ( m,ans,sum,bjp,bj )
                JNjsum>
                %1 %=
                ITE
                   ::
                     ( m,ans,sum,bjp,bj )
                     ROTOVER %+
                     ( m,ans,bjp,bj,sum+bj )
                     UNROT
                     ( m,ans,sum+bj,bjp,bj )
                     %0 >JNjsum
                   ;
                   ::
                     %1 >JNjsum
                   ;
                ( m,ans,sum,bjp,bj )
                ISTOP@ INDEX@ #- UNCOERCE
                JNn>
                %=
                IT
                   ::
                     ( ans=bjp )
                     ( m,ans,sum,bjp,bj )
                     4ROLL DROP
                     ( m,sum,bjp,bj )
                     OVER
                     4UNROLL
                     ( m,bjp,sum,bjp,bj )
                   ;
            LOOP (LOOP)
            ( m,ans,sum,bjp,bj )
            ROT %2 %* SWAP %-
            ( m,ans,bjp,2*sum-bj )
            SWAPDROP
            %/
            ( m,ans )
          ;
     JNx> %0 %<
     JNn> %2 %MOD %1 %=
     AND
     IT %CHS

     ABND
     ;
;
*****************************************************************
NULLNAME BESY0
*
::
   ( x -- real )
   DUP%0= case
                ::
                   ( x )
                   DROP %-MAXREAL
                   ( MAXREAL instead of infinity )
                ;
   DUP %8 %< case
                ::
                   ( x )
                   DUPDUP %* DUP
                   ( x,y,y )
                   R3
                   ( x,y,y,meta )
                   EVPO
                   ( x,y,z )
                   SWAP S3
                   ( x,z,y,meta )
                   EVPO
                   ( x,z,n )
                   %/
                   SWAP
                   ( z/n,x )
                   DUP BESJ0
                   SWAP %LN
                   %*
                   % 0.636619772 %*
                   %+
                ;
   TRUE case
                ::
                   ( x )
                   %8 OVER %/
                   ( x,z )
                   OVER % 0.785398164 %-
                   ( x,z,xx )
                   OVERDUP %*
                   ( x,z,xx,y )
                   DUP P1 EVPO
                   ( ax,z,xx,y,pyp )
                   3PICK %>%% %%SINRAD %%>% %* ( ... )
                   ( ax,z,xx,y,pyp*cos )
                   SWAP Q1 EVPO
                   ( ax,z,xx,pyp*cos,pyq )
                   ROT %>%% %%COSRAD %%>% %*  ( ... )
                   ( ax,z,pyp*cos,pyq*sin )
                   ROT %*
                   %+
                   ( ax,pyp*cos-z*pyq*sin )
                   % 0.636619772 ROT %/ %SQRT
                   %*
                ;
;
*****************************************************************
NULLNAME BESY1
*
::
   ( x -- real )
   DUP%0= case
                ::
                   ( x )
                   DROP %-MAXREAL
                   ( MAXREAL ~ infinity )
                ;
   DUP %8 %< case
                ::
                   ( x )
                   DUPDUP %* DUP
                   ( x,y,y )
                   R4
                   ( x,y,y,meta )
                   EVPO
                   ( x,y,z' )
                   3PICK %*
                   ( x,y,z )
                   SWAP S4
                   ( x,z,y,meta )
                   EVPO
                   ( x,z,n )
                   %/
                   SWAP
                   ( z/n,x )
                   DUP BESJ1
                   OVER %LN
                   %*
                   ( z/n,x,besj0*log )
                   SWAP %1/
                   %-
                   ( z/n,besj0*log-1/x )
                   % 0.636619772 %*
                   %+
                ;
   TRUE case
                ::
                   ( x )
                   %8 OVER %/
                   ( x,z )
                   OVER % 2.356194491 %-
                   ( x,z,xx )
                   OVERDUP %*
                   ( x,z,xx,y )
                   DUP P2 EVPO
                   ( x,z,xx,y,pyp )
                   3PICK %>%% %%SINRAD %%>% %*  ( ... )
                   ( x,z,xx,y,pyp*sin )
                   SWAP Q2 EVPO
                   ( x,z,xx,pyp*sin,pyq )
                   ROT %>%% %%COSRAD %%>% %*
                   ( x,z,pyp*sin,pyq*cos )
                   ROT %*
                   %+
                   ( x,pyp*sin+z*pyq*cos )
                   % 0.636619772 ROT %/ %SQRT
                   %*
                   ( ans )
                ;
;
*****************************************************************
NULLNAME BESYN
*
::
   ( n,x -- integer,real )

   ( x -- real )
   DUP %0= case
                ::
                   ( n,x )
                   2DROP %-MAXREAL
                   ( MAXREAL ~ infinity )
                ;
   TRUE case
                ::
                   %2 OVER %/
                   ( n,x,tox )
                   OVER BESY0
                   ( n,x,tox,bym )
                   ROT BESY1
                   ( n,tox,bym,by )
                   4ROLL COERCE
                   ONE_DO (DO)
                       ( tox,bym,by )
                       INDEX@ UNCOERCE OVER %*
                       ( tox,bym,by,i*by )
                       4PICK %*
                       ( tox,bym,by,i*by*tox )
                       ROT %-
                       ( tox,by,i*by*tox-bym )
                   LOOP (LOOP)
                   ( tox,bym,by )
                   SWAPDROP SWAPDROP
                   ( by )
                ;
;
*****************************************************************
NULLNAME BESI0
*
::
   ( x -- real )
   DUP %ABS % 3.75 %<
   ITE
      ::
         ( x )
         % 3.75 %/ DUP %*
         ( y )
         R5
         ( y,meta )
         EVPO
         ( ans )
      ;
      ::
         ( x )
         %ABS
         ( ax )
         % 3.75 OVER %/
         ( ax,y )
         P5 EVPO
         ( ax,sum )
         OVER %EXP
         ( ax,sum,exp )
         ROT %SQRT %/ %*
         ( ans )
      ;
;
*****************************************************************
NULLNAME BESI1
*
::
   ( x -- real )
   DUP %ABS % 3.75 %<
   ITE
      ::
         ( x )
         DUP %ABS SWAP
         % 3.75 %/ DUP %*
         ( ax,y )
         R6
         ( ax,y,meta )
         EVPO
         ( ax,ans )
         %*
      ;
      ::
         ( x )
         %ABS
         ( ax )
         % 3.75 OVER %/
         ( ax,y )
         DUP P6 EVPO
         ( ax,y,ans1 )
         Q5 get1 SWAP #1+
         ( ax,y,meta )
         EVPO
         ( ax,ans2 )
         OVER %EXP
         ( ax,sum2,exp )
         ROT %SQRT %/ %*
         ( ans )
      ;
;
*****************************************************************
NULLNAME BESIN
*
::
   DEFINE INtox>  1GETLAM
   DEFINE >INtox  1PUTLAM
   DEFINE INx>    2GETLAM
   DEFINE >INx    2PUTLAM
   DEFINE INn>    3GETLAM
   DEFINE >INn    3PUTLAM

   ( n,x -- integer,real )
   DUP%0=
   ITE
      ::
        ( n,x )
        SWAPDROP
        ( x )
      ;
      ::
        %2 OVER %ABS %/
        ( n,x,tox )
        { NULLLAM NULLLAM NULLLAM }
        BIND

            %0 %0 %1
            ( ans,bip,bi )
            INn> % 40.0 %* %SQRT %IP INn> %+ %2 %*
            COERCE
            ONE_DO (DO)
                ( ans,bip,bi )
                ISTOP@ INDEX@ #- UNCOERCE
                INtox> %* OVER %*
                ( ans,bip,bi,i*tox*bi )
                ROT %+
                ( ans,bi,i*tox*bi+bip )
                DUP
                ( BIGNO )
                %ABS % 1.0e10 %>
                IT
                   ::
                     ( ans,bip,bi )
                     % 1.0e-10 %* 3UNROLL
                     % 1.0e-10 %* 3UNROLL
                     % 1.0e-10 %* 3UNROLL
                   ;
                ISTOP@ INDEX@ #- UNCOERCE
                INn>
                %=
                IT
                   ::
                     ( ans=bip )
                     ( ans,bip,bi )
                     ROTDROP OVER
                     UNROT
                   ;
            LOOP (LOOP)
            ( ans,bip,bi )
            SWAPDROP
            INx> BESI0
            ( ans,bi,besi0 )
            SWAP %/
            %*

            INx> %0 %<
            INn> %2 %MOD %1 %=
            AND
            IT %CHS
        ABND
      ;
;
*****************************************************************
NULLNAME BESK0
*
::
   ( x -- real )
   DUP %0= case
                ::
                   ( x )
                   DROP %MAXREAL
                   ( MAXREAL instead of infinity )
                ;
   DUP %2 %< case
                ::
                   ( x )
                   DUPDUP %* %4 %/
                   ( x,y )
                   OVER BESI0
                   ( x,y,besi0 )
                   ROT %2 %/ %LN %CHS
                   %*
                   ( y,-ln*besi0 )
                   SWAP R7
                   ( -ln*besi0,y,meta )
                   EVPO
                   ( -ln*besi0,poly )
                   %+
                ;
   TRUE case
                ::
                   ( x )
                   %2 OVER %/
                   ( x,y )
                   OVER %CHS %EXP
                   ( x,y,exp )
                   ROT %SQRT %/
                   ( y,exp/sqrt )
                   SWAP P7
                   ( exp/sqrt,y,meta )
                   EVPO %*
                   ( ans )
                ;
;
*****************************************************************
NULLNAME BESK1
*
::
   ( x -- real )
   DUP %0= case
                ::
                   ( x )
                   DROP %MAXREAL
                   ( MAXREAL instead of infinity )
                ;
   DUP %2 %< case
                ::
                   ( x )
                   DUP %2 %/ %LN
                   ( x,log )
                   OVER BESI1
                   ( x,log,besi1 )
                   %*
                   SWAPDUP %1/ SWAP
                   ( log*besi1,1/x,x )
                   DUP %* %4 %/
                   ( log*besi1,1/x,y )
                   R8 EVPO
                   ( log*besi1,1/x,poly )
                   %*
                   %+
                ;
   TRUE case
                ::
                   ( x )
                   %2 OVER %/
                   ( x,y )
                   OVER %CHS %EXP
                   ( x,y,exp )
                   ROT %SQRT %/
                   ( y,exp/sqrt )
                   SWAP P8
                   ( exp/sqrt,y,meta )
                   EVPO %*
                   ( ans )
                ;
;
*****************************************************************
NULLNAME BESKN
*
::
   ( n,x -- integer,real )

   ( x -- real )
   DUP %0= case
                ::
                   ( n,x )
                   2DROP %MAXREAL
                   ( MAXREAL ~ infinity )
                ;
   TRUE case
                ::
                   %2 OVER %/
                   ( n,x,tox )
                   OVER BESK0
                   ( n,x,tox,bkm )
                   ROT BESK1
                   ( n,tox,bkm,bk )
                   4ROLL COERCE
                   ONE_DO (DO)
                       ( tox,bkm,bk )
                       INDEX@ UNCOERCE OVER %*
                       ( tox,bkm,by,i*bk )
                       4PICK %*
                       ( tox,bkm,bk,i*bk*tox )
                       ROT %+
                       ( tox,bk,i*bk*tox+bkm )
                   LOOP (LOOP)
                   ( tox,bkm,bk )
                   SWAPDROP SWAPDROP
                   ( bk )
                ;
;
*****************************************************************
NULLNAME EVPO
*
::
  ( b,a -- real,meta )
  get1
  ( a.1,...,a.n,#n,b )
  UNROT
  ( a.1,...,b,a.n,#n )
  ONE_DO (DO)
      ( a.1,...,a.n-1,b,a.n )
      OVER
      ( a.1,...,a.n-1,b,a.n,b )
      %*
      ( a.1,...,a.n-1,b,b*a.n )
      ROT
      ( a.1,...,b,b*a.n,a.n-1 )
      %+
      ( a.1,...,b,b*a.n+a.n-1 )
  LOOP (LOOP)
  ( b,result )
  SWAPDROP
;
*****************************************************************
NULLNAME R1
*
::
   % 57568490574.0
   % -13362590354.0
   % 651619640.7
   % -11214424.18
   % 77392.33017
   % -184.9052456
   SIX
;
*****************************************************************
NULLNAME R2
*
::
   % 72362614232
   % -7895059235
   % 242396853.1
   % -2972611.439
   % 15704.4826
   % -30.16036606
   SIX
;
*****************************************************************
NULLNAME R3
*
::
   % -2957821389.0
   % 7062834065.0
   % -512359803.6
   % 10879881.29
   % -86327.92757
   % 228.4622733
   SIX
;
*****************************************************************
NULLNAME R4
*
::
   % -0.4900604943e13
   % 0.1275274390e13
   % -0.5153438139e11
   % 0.7349264551e9
   % -0.4237922726e7
   % 0.8511937935e4
   SIX
;
*****************************************************************
NULLNAME R5
*
::
   %1
   % 3.5156229
   % 3.0899424
   % 1.2067492
   % 0.2659732
   % 0.360768e-1
   % 0.45813e-2
   SEVEN
;
*****************************************************************
NULLNAME R6
*
::
   % 0.5
   % 0.87890594
   % 0.51498869
   % 0.15084934
   % 0.2658733e-1
   % 0.301532e-2
   % 0.32411e-3
   SEVEN
;
*****************************************************************
NULLNAME R7
*
::
   % -0.57721566
   % 0.42278420
   % 0.23069756
   % 0.3488590e-1
   % 0.262698e-2
   % 0.10750e-3
   % 0.74e-5
   SEVEN
;
*****************************************************************
NULLNAME R8
*
::
   %1
   % 0.15443144
   % -0.67278579
   % -0.18156897
   % -0.1919402e-1
   % -0.110404e-2
   % -0.4686e-4
   SEVEN
;
*****************************************************************
NULLNAME P1
*
::
   %1
   % -0.1098628627e-2
   % 0.2734510407e-4
   % -0.2073370639e-5
   % 0.2093887211e-6
   FIVE
;
*****************************************************************
NULLNAME P2
*
::
   %1
   % 0.183105e-2
   % -0.3516396496e-4
   % 0.245752017e-5
   % -0.240337019e-6
   FIVE
;
*****************************************************************
NULLNAME P5
*
::
   % 0.39894228
   % 0.1328592e-1
   % 0.225319e-2
   % -0.00157565
   % 0.00916281
   % -0.02057706
   % 0.02635537
   % -0.01647633
   % 0.392377e-2
   NINE
;
*****************************************************************
NULLNAME P6
*
::
   % 0.2282967e-1
   % -0.2895312e-1
   % 0.1787654e-1
   % -0.420059e-2
   FOUR
;
*****************************************************************
NULLNAME P7
*
::
   % 1.25331414
   % -0.7832358e-1
   % 0.2189568e-1
   % -0.1062446e-1
   % 0.587872e-2
   % -0.251540e-2
   % 0.53208e-3
   SEVEN
;
*****************************************************************
NULLNAME P8
*
::
   % 1.25331414
   % 0.23498619
   % -0.3655620e-1
   % 0.1504268e-1
   % -0.780353e-2
   % 0.325614e-2
   % -0.68245e-3
   SEVEN
;
*****************************************************************
NULLNAME S1
*
::
   % 57568490411.0
   % 1029532985.0
   % 9494680.718
   % 59272.64853
   % 267.8532712
   %1
   SIX
;
*****************************************************************
NULLNAME S2
*
::
   % 144725228442.0
   % 2300535178.0
   % 18583304.74
   % 99447.43394
   % 376.9991397
   %1
   SIX
;
*****************************************************************
NULLNAME S3
*
::
   % 40076544269.0
   % 745249964.8
   % 7189466.438
   % 47447.26470
   % 226.1030244
   %1
   SIX
;
*****************************************************************
NULLNAME S4
*
::
   % 0.2499580570e14
   % 0.4244419664e12
   % 0.3733650367e10
   % 0.2245904002e8
   % 0.102042050e6
   % 0.3549632885e3
   %1
   SEVEN
;
*****************************************************************
NULLNAME Q1
*
::
   % -0.1562499995e-1
   % 0.1430488765e-3
   % -0.6911147651e-5
   % 0.7621095161e-6
   % -0.934945152e-7
   FIVE
;
*****************************************************************
NULLNAME Q2
*
::
   % 0.04687499995
   % -0.2002690873e-3
   % 0.8449199096e-5
   % -0.88228987e-6
   % 0.105787412e-6
   FIVE
;
*****************************************************************
NULLNAME Q5
*
::
   % 0.39894228
   % -0.3988024e-1
   % -0.362018e-2
   % 0.163801e-2
   % -0.1031555e-1
   FIVE
;
*****************************************************************
NULLNAME GSER
*
::
  DEFINE   GSITMAX   ONEHUNDRED  ( max. number of iterations )
  DEFINE   GSEPS     % 3.0e-7    ( epsilon )

  ( a,x )
  DUP%0=
  ITE
     ::
       ( a,x )
       SWAPDROP
       ( x )
     ;
     ::
       ( a,x )
       OVER %1/
       ( a,x,del )
       DUP 4PICK
       ( a,x,del,sum,ap )

       FOUR SetUserFlag

       GSITMAX
       ONE_DO (DO)

          ( a,x,del,sum,ap )
          %1+ ROT
          ( a,x,sum,ap,del )
          4PICK %*
          ( a,x,sum,ap,del*x )
          OVER %/
          ( a,x,sum,ap,del*x/ap )
          ROTOVER
          ( a,x,ap,del,sum,del )
          %+ ROT
          ( a,x,del,sum,ap )

          OVER %ABS % 3.0e-7 %*
          ( a,x,del,sum,ap,As )
          4PICK %ABS
          ( a,x,del,su,ap,As,Ad )
          %>
          IT :: FOUR ClrUserFlag ExitAtLOOP ;
          ( a,x,del,sum,ap )

       LOOP (LOOP)
       ( a,x,del,sum,ap )
       DROPSWAPDROP
       ( a,x,sum )

       FOUR TestUserFlag
       IT ITMAXERR           ( flash error message )

       ( a,x,sum )
       UNROT DUP
       %LN
       ( sum,a,x,lnx )
       3PICK %* SWAP %-
       ( sum,a,a*lnx-x )
       SWAP
       %1- %FACT %LN %-
       ( sum,a*lnx-x-glna )
       %EXP
       %*
       ( gser )
     ;
;
*****************************************************************
NULLNAME ITMAXERR
*
::
  $ "ITMAX too small"
  FlashMsg
;
*****************************************************************
NULLNAME GCF
*
::
  DEFINE  GCFITMAX   %100
  DEFINE  GCFEPS     % 3.0e-7
  DEFINE  GCFFPMIN   % 1.0e-30

  DEFINE   GCFC>   1GETLAM
  DEFINE   >GCFC   1PUTLAM
  DEFINE   GCFH>   2GETLAM
  DEFINE   >GCFH   2PUTLAM
  DEFINE   GCFD>   3GETLAM
  DEFINE   >GCFD   3PUTLAM
  DEFINE   GCFB>   4GETLAM
  DEFINE   >GCFB   4PUTLAM


  ( a,x )
  DUP %1+ 3PICK %-
  ( a,x,b )
  DUP %1/ DUP
  ( a,x,b,d,h )
  % 1.0e+30
  ( a,x,b,d,h,c )

  { NULLLAM NULLLAM NULLLAM NULLLAM }
  BIND
  ( a,x )

  %0
  BEGIN

     %1+
     ( a,x,i )
     3PICK OVER %- OVER %*
     ( a,x,i,an )
     GCFB> %2 %+ DUP >GCFB
     ( a,x,i,an,b )
     OVER GCFD> %*
     ( a,x,i,an,b,an*d )
     OVER %+
     ( a,x,i,an,b,d=an*d+b )
         DUP %ABS GCFFPMIN %< IT :: DROP GCFFPMIN ;
     ( a,x,i,an,b,d )
     %1/ DUP >GCFD
     ( a,x,i,an,b,d )
     ROT GCFC> %/
     ( a,x,i,b,d,an/c )
     ROT %+
     ( a,x,i,d,an/c+b=c )
         DUP %ABS GCFFPMIN %< IT :: DROP GCFFPMIN ;
     DUP >GCFC
     ( a,x,i,d,c )
     %* GCFH> OVER %* >GCFH
     ( a,x,i,del )

     %1- %ABS GCFEPS %<
     ( a,x,i,T/F )
     OVER GCFITMAX %>
     OR
     ( a,x,i,T/F )

  UNTIL

  ( a,x,i )
  GCFITMAX %>
  IT ITMAXERR           ( flash error message  )

  ( a,x )
  DUP %LN 3PICK %*
  ( a,x,lnx*a )
  SWAP %-
  ( a,lnx*a-x )
  SWAP %1- %FACT %LN
  %-
  ( lnx*a-x-gln )
  %EXP
  GCFH> %*
  ( gcf )

  ABND
;
*****************************************************************
NULLNAME ERFX
*
::
  ( x )
  DUP%0= ?SEMI
  DUP %SGN
  ( x,sx )
  %0 %.5 4ROLL %ABS
  ( sx,0,1/2,ax )
  xUTPN
  ( sx,ru )
  %-2 %* %1+
  ( sx,rum )
  %*
;
*****************************************************************
NULLNAME NPLM
*
::
  ( l,m,x )
  %1
  ( l,m,x,pmm )

  3PICK %0 %>
  IT
    ::
      ( l,m,x,pmm )
      %1 3PICK %-
      ( l,m,x,pmm,1-x )
      3PICK %1+
      ( l,m,x,pmm,1-x,1+x )
      %* %SQRT %1
      ( l,m,x,pmm,somx2,fact )
      ROT
      ( l,m,x,somx2,fact,pmm )
      5PICK COERCE
      #1+_ONE_DO

         3PICK3PICK %* %CHS
         ( l,m,x,somx2,fact,pmm,-somx2*fact )
         %* SWAP %2 %+ SWAP
         ( l,m,x,somx2,fact,pmm )

      LOOP
      SWAPDROP SWAPDROP
      ( l,m,x,pmm )
    ;

    4PICK 4PICK
    ( l,m,x,pmm,l,m )
    %=
    ITE
       ::
         ( l,m,x,pmm )
         4UNROLL 3DROP
         ( pmm )
       ;
       ::
         ( l,m,x,pmm )
         3PICK %2 %* %1+
         ( l,m,x,pmm,2m1 )
         3PICK %* OVER %*
         ( l,m,x,pmm,pmmp1 )
         5PICK 5PICK %1+ %=
         ITE
            ::
              ( l,m,x,pmm,pmmp1 )
              5UNROLL 4DROP
              ( pmmp1 )
            ;
            ::
              ( l,m,x,pmm,pmmp1 )
              4PICK %2 %+ UNROT
              BEGIN

                 ( l,m,x,i,pmm,pmmp1 )
                 3PICK %2 %* %1-
                 ( l,m,x,i,pmm,pmmp1,2i-1 )
                 OVER %* 5PICK %*
                 ( l,m,x,i,pmm,pmmp1,fh )
                 6PICK 5PICK %+ %1-
                 ( l,m,x,i,pmm,pmmp1,fh,i+m-1 )
                 4ROLL %*
                 ( l,m,x,i,pmmp1,fh,sh )
                 %-
                 3PICK 6PICK %-
                 %/
                 ( l,m,x,i,pmmp1,pll )

                 ROT DUP %1+
                 ( l,m,x,pmmp1,pll,i,i+1 )
                 4UNROLL 7PICK %>=
                 ( l,m,x,i+1,pmmp1,pll,T/F )

              UNTIL
              ( l,m,x,i,pmmp1,pll )
              6UNROLL 5DROP
            ;
       ;
;
*****************************************************************
NULLNAME NYLM
*
::

  ( l,m,th,ph )
  3PICK DUP%0=
  ITE
     ::
       ( l,m,th,ph,m=0 )
       2DROP 3PICK3PICK ROT
       ( l,m,l,m,th )
       %COS
       NPLMX UNROT
       ( plm,l,m )
       NPFYLM
       %*
     ;
     ::
       ( l,m,th,ph,m )
       %* ' xi EvalNoCK
       ' x* EvalNoCK  ( no %c*c in suprom49 ?? )
       ' xEXP
       EvalNoCK
       ( l,m,th,eiph )
       4UNROLL
       ( eiph,l,m,th )
       3PICK3PICK NPFYLM 4UNROLL
       ( eiph,pf,l,m,th )
       %COS NPLMX
       ( eiph,pf,plm )
       %* Re>C% ' x* EvalNoCK
       CRUNCH
     ;
;
*****************************************************************
NULLNAME NPFYLM
*
::
  ( l,m )
  OVER OVER %+ %NFACT
  ( l,m,lpm )
  UNROT
  ( lpm,l,m )
  OVERSWAP %- %NFACT
  ( lpm,l,lmm )
  ROT %/ SWAP
  %2 %* %1+
  %PI %4 %*
  %/
  %*
  %SQRT
;
*****************************************************************
NULLNAME NBETA
*
::
  ( z,w )
  OVER %1- %FACT %LN
  ( z,w,glnz )
  OVER %1- %FACT %LN
  ( z,w,glnz,glnw )
  %+
  UNROT
  ( glnz+glnw,z,w )
  %+ %1- %FACT %LN
  ( glnz+glnw,glnwz )
  %-
  %EXP
;
*****************************************************************
NULLNAME NIBETA
*
::
  ( a,b,x )
  DUP%0= OVER %1 %= OR
  ITE
     ::
       ( a,b,x )
       %0
     ;
     ::
       ( a,b,x )
       %1 OVER %- %LN
       ( a,b,x,ln1x )
       3PICK %*
       ( a,b,x,b*ln1x )
       OVER %LN
       ( a,b,x,bln1x,lnx )
       5PICK %*
       ( a,b,x,bln1x,alnx )
       %+
       4PICK 4PICK 2DUP
       ( a,b,x,bln1x+alnx,a,b,a,b )
       %+ %1- %FACT %LN UNROT
       ( a,b,x,bln1x+alnx,glnab,a,b )
       %1- %FACT %LN
       SWAP
       %1- %FACT %LN
       %+
       ( a,b,x,bln1-x+alnx,glnab,glna+glnb )
       %- %+
       %EXP
       ( a,b,x,bt )
     ;
  ( a,b,x,bt )
  4PICK
  ( a,b,x,bt,a )
  %1+ 4PICK
  ( a,b,x,bt,a+1,b )
  OVER %+ %1+
  ( a,b,x,bt,a+1,a+b+2 )
  %/
  3PICK
  ( a,b,x,bt,a1/ab2,x )
  %>
  ITE
     ::
       ( a,b,x,bt )
       4PICK %/ 4UNROLL
       ( bt/a,a,b,x )
       BETACF
       %*
     ;
     ::
       ( a,b,x,bt )
       3PICK %/ 4UNROLL
       ( bt/b,a,b,x )
       %1 SWAP %-
       ( bt/b,a,b,1-x )
       ROTSWAP
       ( bt/b,b,a,1-x )
       BETACF
       %*
       %1 SWAP %-
     ;
  ( ibeta )

;
*****************************************************************
NULLNAME BETACF
*
::
   DEFINE   BCMAXIT    %100
   DEFINE   BCEPS      % 3.0e-7
   DEFINE   BCFPMIN    % 1.0e-30

   DEFINE   BCC>       1GETLAM
   DEFINE   >BCC       1PUTLAM
   DEFINE   BCH>       2GETLAM
   DEFINE   >BCH       2PUTLAM
   DEFINE   BCD>       3GETLAM
   DEFINE   >BCD       3PUTLAM
   DEFINE   BCAM>      4GETLAM
   DEFINE   >BCAM      4PUTLAM
   DEFINE   BCAP>      5GETLAM
   DEFINE   >BCAP      5PUTLAM
   DEFINE   BCAB>      6GETLAM
   DEFINE   >BCAB      6PUTLAM
   DEFINE   BCB>       7GETLAM
   DEFINE   >BCB       7PUTLAM
   DEFINE   BCA>       8GETLAM
   DEFINE   >BCA       8PUTLAM
   DEFINE   BCX>       9GETLAM
   DEFINE   >BCX       9PUTLAM

   ( a,b,x )
   UNROT 2DUP
   ( x,a,b,a,b )
   OVER %+
   ( x,a,b,a,a+b )
   OVER %1+
   ROT  %1-
   ( x,a,b,a+b,a+1,a-1 )
   6PICK 4PICK %*
   ( x,a,b,a+b,a+1,a-1,x*ab )
   3PICK %/
   ( x,a,b,a+b,a+1,a-1,x*ab/ap )
   %1 SWAP %-
   ( x,a,b,a+b,a+1,a-1,d )
       DUP %ABS BCFPMIN %< IT :: DROP BCFPMIN ;
   %1/ DUP
   ( x,a,b,a+b,a+1,a-1,d,h )
   %1
   ( x,a,b,a+b,a+1,a-1,d,h,c )

   NULLLAM NINE NDUPN
   DOBIND

      ( )
      %0

      BEGIN

         %1+
         ( m )
         DUP %2 %*
         ( m,m2 )
         BCB> 3PICK %- BCX> %*
         ( m,m2,bmx )
         OVER BCAM> %+
         ( m,m2,bmx,amm2 )
         ROT BCA> %+
         ( m,bmx,amm2,am2 )
         %* %/
         OVER %*
         ( m,aa )
         BCD> OVER %* %1+
         ( m,aa,d )
               DUP %ABS BCFPMIN %< IT :: DROP BCFPMIN ;
         %1/ DUP >BCD
         ( m,aa,d )
         SWAP BCC> %/
         ( m,d,aa/c )
         %1+
         ( m,d,c )
               DUP %ABS BCFPMIN %< IT :: DROP BCFPMIN ;
         ( m,d,c )
         DUP >BCC
         %* BCH> %* >BCH
         ( m )

         BCA> OVER %+
         ( m,am )
         OVER BCAB> %+
         ( m,am,abm )
         %* BCX> %* %CHS
         ( m,-amabmx )
         OVER %2 %*
         ( m,-amabmx,m2 )
         BCA> OVER %+
         ( m,-amabmx,m2,am2 )
         SWAP BCAP> %+
         ( m,-amabmx,am2,apm2 )
         %* %/
         ( m,aa )
         BCD> OVER %* %1+
         ( m,aa,d )
               DUP %ABS BCFPMIN %< IT :: DROP BCFPMIN ;
         ( m,aa,d )
         %1/ DUP >BCD
         ( m,aa,d )
         SWAP BCC> %/ %1+
         ( m,d,c )
               DUP %ABS BCFPMIN %< IT :: DROP BCFPMIN ;
         ( m,d,c )
         DUP >BCC
         %* DUP BCH> %* >BCH

         ( m,del )
         %1- BCEPS %<=
         ( m,T/F )
         OVER BCMAXIT %=
         ( m,T/F,T/F )
         OR

      UNTIL
      ( m )
      BCMAXIT %= IT ITMAXERR
      ( )

      BCH>

   ABND
;
*****************************************************************
